/*
** hdrcache.h - 
**
** Keith Zaback (krz@wcug.wwu.edu) Apr 98
*/

#ifndef INC_HDRCACHE_H
#define INC_HDRCACHE_H

#include "ipx.h"

/* more handy stuff */
#define HDRCACHE_GETIPX(x,i)	(&(x.table[i].ipx_header))

/* defines for hdrcache_entry.flags */
#define CACHE_VALID		0x0001	/* vaild entry */
#define CACHE_ACCESSED		0x0002	/* has been used recently */
#define CACHE_STORE_REQ		0x0004	/* a request has been made to store this */
#define CACHE_STORE_ACK		0x0008	/* the request has been acked */

/* when a cache entry is new, set these and only these flags */
#define CACHE_NEW_FLAGS		(CACHE_VALID | CACHE_ACCESSED)

typedef struct stHDRCACHE_ENTRY {
	int		flags;		/* cache flags */
	int		access_remove;	/* counter to remove certain bits */
	IPXHEADER	ipx_header;	/* the header with length set to zero */
	int		used_count;	/* for info */
	int		clear_req;	/* number of clear req's we have sent out */
} HDRCACHE_ENTRY;

typedef struct stHDRCACHE {
	int		size;		/* number of entries total */
	int		used;		/* how many are used */
	HDRCACHE_ENTRY	*table;		/* array of entries */
} HDRCACHE;

/* protos */
void		free_hdrcache(HDRCACHE *cache);
int		create_hdrcache(HDRCACHE *cache, int size);
int		hdrcache_lookup(HDRCACHE *cache, IPXHEADER *header);
int		hdrcache_insert(HDRCACHE *cache, IPXHEADER *header);
void		hdrcache_flush(HDRCACHE *cache);
void		hdrcache_maint(HDRCACHE *cache);
IPXHEADER	*hdrcache_ipxheader(HDRCACHE *cache, int num);
void		hdrcache_dump(HDRCACHE *cache);

#endif
